Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 107148)
@@ -875,5 +875,4 @@
 	src/settings/editors/UIBootOrderEditor.h \
 	src/settings/editors/UIChipsetEditor.h \
-	src/settings/editors/UIColorThemeEditor.h \
 	src/settings/editors/UIDefaultMachineFolderEditor.h \
 	src/settings/editors/UIDescriptionEditor.h \
@@ -926,5 +925,4 @@
 	src/settings/global/UIGlobalSettingsLanguage.h \
 	src/settings/global/UIGlobalSettingsDisplay.h \
-	src/settings/global/UIGlobalSettingsInterface.h \
 	src/settings/machine/UIMachineSettingsAudio.h \
 	src/settings/machine/UIMachineSettingsDisplay.h \
@@ -1460,5 +1458,4 @@
 	src/settings/editors/UIBootOrderEditor.cpp \
 	src/settings/editors/UIChipsetEditor.cpp \
-	src/settings/editors/UIColorThemeEditor.cpp \
 	src/settings/editors/UIDefaultMachineFolderEditor.cpp \
 	src/settings/editors/UIDescriptionEditor.cpp \
@@ -1511,5 +1508,4 @@
 	src/settings/global/UIGlobalSettingsLanguage.cpp \
 	src/settings/global/UIGlobalSettingsDisplay.cpp \
-	src/settings/global/UIGlobalSettingsInterface.cpp \
 	src/settings/machine/UIMachineSettingsAudio.cpp \
 	src/settings/machine/UIMachineSettingsDisplay.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 107148)
@@ -1629,50 +1629,4 @@
 }
 
-/* QString <= UIColorThemeType: */
-template<> SHARED_LIBRARY_STUFF QString UIConverter::toString(const UIColorThemeType &colorThemeType) const
-{
-    QString strResult;
-    switch (colorThemeType)
-    {
-        case UIColorThemeType_Auto:  strResult = QApplication::translate("UICommon", "Follow System Settings", "color theme"); break;
-        case UIColorThemeType_Light: strResult = QApplication::translate("UICommon", "Light", "color theme"); break;
-        case UIColorThemeType_Dark:  strResult = QApplication::translate("UICommon", "Dark", "color theme"); break;
-        default:
-        {
-            AssertMsgFailed(("No text for color theme type=%d", colorThemeType));
-            break;
-        }
-    }
-    return strResult;
-}
-
-/* QString <= UIColorThemeType: */
-template<> SHARED_LIBRARY_STUFF QString UIConverter::toInternalString(const UIColorThemeType &colorThemeType) const
-{
-    QString strResult;
-    switch (colorThemeType)
-    {
-        case UIColorThemeType_Auto:  break;
-        case UIColorThemeType_Light: strResult = "Light"; break;
-        case UIColorThemeType_Dark:  strResult = "Dark"; break;
-        default:
-        {
-            AssertMsgFailed(("No text for color theme type=%d", colorThemeType));
-            break;
-        }
-    }
-    return strResult;
-}
-
-/* UIColorThemeType <= QString: */
-template<> UIColorThemeType SHARED_LIBRARY_STUFF UIConverter::fromInternalString<UIColorThemeType>(const QString &strColorThemeType) const
-{
-    if (strColorThemeType.compare("Light", Qt::CaseInsensitive) == 0)
-        return UIColorThemeType_Light;
-    if (strColorThemeType.compare("Dark", Qt::CaseInsensitive) == 0)
-        return UIColorThemeType_Dark;
-    return UIColorThemeType_Auto;
-}
-
 /* UILaunchMode <= QString: */
 template<> UILaunchMode SHARED_LIBRARY_STUFF UIConverter::fromInternalString<UILaunchMode>(const QString &strDefaultFrontendType) const
@@ -2111,5 +2065,4 @@
         case GlobalSettingsPageType_Proxy:      strResult = "Proxy"; break;
 #endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
-        case GlobalSettingsPageType_Interface:  strResult = "Interface"; break;
         default:
         {
@@ -2140,6 +2093,4 @@
         return GlobalSettingsPageType_Proxy;
 #endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
-    if (strGlobalSettingsPageType.compare("Interface", Qt::CaseInsensitive) == 0)
-        return GlobalSettingsPageType_Interface;
     return GlobalSettingsPageType_Invalid;
 }
@@ -2160,5 +2111,4 @@
         case GlobalSettingsPageType_Proxy:      return UIIconPool::pixmap(":/proxy_warning_16px.png");
 #endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
-        case GlobalSettingsPageType_Interface:  return UIIconPool::pixmap(":/interface_warning_16px.png");
         default: AssertMsgFailed(("No pixmap for %d", type)); break;
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 107148)
@@ -32,5 +32,4 @@
 /* General: */
 const char *UIExtraDataDefs::GUI_RestrictedDialogs = "GUI/RestrictedDialogs";
-const char *UIExtraDataDefs::GUI_ColorTheme = "GUI/ColorTheme";
 
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 107148)
@@ -53,7 +53,4 @@
         /** Holds restricted dialogs. */
         SHARED_LIBRARY_STUFF extern const char *GUI_RestrictedDialogs;
-
-        /** Holds the color theme type. */
-        SHARED_LIBRARY_STUFF extern const char *GUI_ColorTheme;
     /** @} */
 
@@ -872,5 +869,4 @@
     GlobalSettingsPageType_Proxy,
 #endif
-    GlobalSettingsPageType_Interface,
     GlobalSettingsPageType_Max
 };
@@ -936,14 +932,4 @@
     WizardMode_Expert
 };
-
-
-/** Common UI: Color Theme types. */
-enum UIColorThemeType
-{
-    UIColorThemeType_Auto,
-    UIColorThemeType_Light,
-    UIColorThemeType_Dark,
-};
-Q_DECLARE_METATYPE(UIColorThemeType);
 
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 107148)
@@ -2334,14 +2334,4 @@
 }
 
-UIColorThemeType UIExtraDataManager::colorTheme()
-{
-    return gpConverter->fromInternalString<UIColorThemeType>(extraDataString(GUI_ColorTheme));
-}
-
-void UIExtraDataManager::setColorTheme(const UIColorThemeType &enmType)
-{
-    setExtraDataString(GUI_ColorTheme, gpConverter->toInternalString(enmType));
-}
-
 QStringList UIExtraDataManager::suppressedMessages(const QUuid &uID /* = GlobalID */)
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 107148)
@@ -190,9 +190,4 @@
         /** Defines a list of restricted dialogs. */
         void setRestrictedDialogTypes(UIExtraDataMetaDefs::DialogType enmTypes, const QUuid &uID);
-
-        /** Returns color theme type. */
-        UIColorThemeType colorTheme();
-        /** Defines color theme @a enmType. */
-        void setColorTheme(const UIColorThemeType &enmType);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 107148)
@@ -817,18 +817,8 @@
 bool UICommon::isWindowsInDarkMode() const
 {
-    /* Load saved color theme: */
-    UIColorThemeType enmColorTheme = gEDataManager->colorTheme();
-
-    /* Check whether we have dark system theme requested: */
-    if (enmColorTheme == UIColorThemeType_Auto)
-    {
-        QSettings settings("HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Themes\\Personalize",
-                           QSettings::NativeFormat);
-        if (settings.value("AppsUseLightTheme") == 0)
-            enmColorTheme = UIColorThemeType_Dark;
-    }
-
-    /* Return result: */
-    return enmColorTheme == UIColorThemeType_Dark;
+    /* Check if Windows registry has no Light flag, that means system will use Dark mode: */
+    QSettings settings("HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Themes\\Personalize",
+                       QSettings::NativeFormat);
+    return settings.value("AppsUseLightTheme") == 0;
 }
 
@@ -920,37 +910,5 @@
     }
 
-#elif defined(VBOX_WS_WIN)
-
-    /* For the Dark mode! */
-    if (isInDarkMode())
-    {
-        qApp->setStyle(QStyleFactory::create("Fusion"));
-        QPalette darkPalette;
-        QColor windowColor1 = QColor(59, 60, 61);
-        QColor windowColor2 = QColor(63, 64, 65);
-        QColor baseColor1 = QColor(46, 47, 48);
-        QColor baseColor2 = QColor(56, 57, 58);
-        QColor disabledColor = QColor(113, 114, 115);
-        darkPalette.setColor(QPalette::Window, windowColor1);
-        darkPalette.setColor(QPalette::WindowText, Qt::white);
-        darkPalette.setColor(QPalette::Disabled, QPalette::WindowText, disabledColor);
-        darkPalette.setColor(QPalette::Base, baseColor1);
-        darkPalette.setColor(QPalette::AlternateBase, baseColor2);
-        darkPalette.setColor(QPalette::PlaceholderText, disabledColor);
-        darkPalette.setColor(QPalette::Text, Qt::white);
-        darkPalette.setColor(QPalette::Disabled, QPalette::Text, disabledColor);
-        darkPalette.setColor(QPalette::Button, windowColor2);
-        darkPalette.setColor(QPalette::ButtonText, Qt::white);
-        darkPalette.setColor(QPalette::Disabled, QPalette::ButtonText, disabledColor);
-        darkPalette.setColor(QPalette::BrightText, Qt::red);
-        darkPalette.setColor(QPalette::Link, QColor(179, 214, 242));
-        darkPalette.setColor(QPalette::Highlight, QColor(29, 84, 92));
-        darkPalette.setColor(QPalette::HighlightedText, Qt::white);
-        darkPalette.setColor(QPalette::Disabled, QPalette::HighlightedText, disabledColor);
-        qApp->setPalette(darkPalette);
-        qApp->setStyleSheet("QToolTip { color: #ffffff; background-color: #2b2b2b; border: 1px solid #737373; }");
-    }
-
-#else /* Linux, BSD, Solaris */
+#elif defined(VBOX_WS_NIX) /* Linux, BSD, Solaris */
 
     /* For the Dark mode! */
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 107134)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 107148)
@@ -47,7 +47,4 @@
 #include "UIGlobalSettingsInput.h"
 #include "UIGlobalSettingsLanguage.h"
-#ifdef VBOX_WS_WIN
-# include "UIGlobalSettingsInterface.h"
-#endif
 #ifdef VBOX_GUI_WITH_NETWORK_MANAGER
 # include "UIGlobalSettingsProxy.h"
@@ -113,9 +110,4 @@
 #endif
 
-#ifdef VBOX_WS_WIN
-    /* Interface page: */
-    m_pSelector->setItemText(GlobalSettingsPageType_Interface, tr("Interface"));
-#endif
-
     /* Polish the selector: */
     m_pSelector->polish();
@@ -258,15 +250,4 @@
                 }
 #endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
-#ifdef VBOX_WS_WIN
-                /* Interface page: */
-                case GlobalSettingsPageType_Interface:
-                {
-                    pSettingsPage = new UIGlobalSettingsInterface;
-                    addItem(":/interface_32px.png", ":/interface_24px.png", ":/interface_16px.png",
-                            iPageIndex, "#userInterface", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences");
-                    break;
-                }
-#endif /* VBOX_WS_WIN */
                 default:
                     break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIColorThemeEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIColorThemeEditor.cpp	(revision 107134)
+++ 	(revision )
@@ -1,147 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIColorThemeEditor class implementation.
- */
-
-/*
- * Copyright (C) 2019-2024 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-/* Qt includes: */
-#include <QComboBox>
-#include <QGridLayout>
-#include <QHBoxLayout>
-#include <QLabel>
-
-/* GUI includes: */
-#include "UIColorThemeEditor.h"
-#include "UIConverter.h"
-
-
-UIColorThemeEditor::UIColorThemeEditor(QWidget *pParent /* = 0 */)
-    : UIEditor(pParent)
-    , m_enmValue(UIColorThemeType_Auto)
-    , m_pLabel(0)
-    , m_pCombo(0)
-{
-    prepare();
-}
-
-void UIColorThemeEditor::setValue(UIColorThemeType enmValue)
-{
-    /* Update cached value and
-     * combo if value has changed: */
-    if (m_enmValue != enmValue)
-    {
-        m_enmValue = enmValue;
-        populateCombo();
-    }
-}
-
-UIColorThemeType UIColorThemeEditor::value() const
-{
-    return m_pCombo ? m_pCombo->currentData().value<UIColorThemeType>() : m_enmValue;
-}
-
-void UIColorThemeEditor::sltRetranslateUI()
-{
-    if (m_pLabel)
-        m_pLabel->setText(tr("Color &Theme:"));
-    if (m_pCombo)
-    {
-        for (int i = 0; i < m_pCombo->count(); ++i)
-        {
-            const UIColorThemeType enmType = m_pCombo->itemData(i).value<UIColorThemeType>();
-            m_pCombo->setItemText(i, gpConverter->toString(enmType));
-        }
-        m_pCombo->setToolTip(tr("Selects the color theme. It can be Light, Dark or automatically detected (default)."));
-    }
-}
-
-void UIColorThemeEditor::prepare()
-{
-    /* Create main layout: */
-    QGridLayout *pLayout = new QGridLayout(this);
-    if (pLayout)
-    {
-        pLayout->setContentsMargins(0, 0, 0, 0);
-
-        /* Create label: */
-        m_pLabel = new QLabel(this);
-        if (m_pLabel)
-            pLayout->addWidget(m_pLabel, 0, 0);
-
-        /* Create combo layout: */
-        QHBoxLayout *pComboLayout = new QHBoxLayout;
-        if (pComboLayout)
-        {
-            /* Create combo: */
-            m_pCombo = new QComboBox(this);
-            if (m_pCombo)
-            {
-                /* This is necessary since contents is dynamical now: */
-                m_pCombo->setSizeAdjustPolicy(QComboBox::AdjustToContents);
-                if (m_pLabel)
-                    m_pLabel->setBuddy(m_pCombo);
-                pComboLayout->addWidget(m_pCombo);
-            }
-
-            /* Add stretch: */
-            pComboLayout->addStretch();
-
-            /* Add combo-layout into main-layout: */
-            pLayout->addLayout(pComboLayout, 0, 1);
-        }
-    }
-
-    /* Populate combo: */
-    populateCombo();
-
-    /* Apply language settings: */
-    sltRetranslateUI();
-}
-
-void UIColorThemeEditor::populateCombo()
-{
-    if (m_pCombo)
-    {
-        /* Clear combo first of all: */
-        m_pCombo->clear();
-
-        /* Get possible values: */
-        QList<UIColorThemeType> possibleValues;
-        possibleValues << UIColorThemeType_Auto
-                       << UIColorThemeType_Light
-                       << UIColorThemeType_Dark;
-
-        /* Update combo with all the possible values: */
-        foreach (const UIColorThemeType &enmType, possibleValues)
-            m_pCombo->addItem(QString(), QVariant::fromValue(enmType));
-
-        /* Look for proper index to choose: */
-        const int iIndex = m_pCombo->findData(QVariant::fromValue(m_enmValue));
-        if (iIndex != -1)
-            m_pCombo->setCurrentIndex(iIndex);
-
-        /* Retranslate finally: */
-        sltRetranslateUI();
-    }
-}
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIColorThemeEditor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIColorThemeEditor.h	(revision 107134)
+++ 	(revision )
@@ -1,78 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIColorThemeEditor class declaration.
- */
-
-/*
- * Copyright (C) 2019-2024 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-#ifndef FEQT_INCLUDED_SRC_settings_editors_UIColorThemeEditor_h
-#define FEQT_INCLUDED_SRC_settings_editors_UIColorThemeEditor_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-/* GUI includes: */
-#include "UIEditor.h"
-#include "UIExtraDataDefs.h"
-
-/* Forward declarations: */
-class QComboBox;
-class QLabel;
-
-/** UIEditor sub-class used as a color theme editor. */
-class SHARED_LIBRARY_STUFF UIColorThemeEditor : public UIEditor
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs editor passing @a pParent to the base-class. */
-    UIColorThemeEditor(QWidget *pParent = 0);
-
-    /** Defines editor @a enmValue. */
-    void setValue(UIColorThemeType enmValue);
-    /** Returns editor value. */
-    UIColorThemeType value() const;
-
-private slots:
-
-    /** Handles translation event. */
-    virtual void sltRetranslateUI() RT_OVERRIDE RT_FINAL;
-
-private:
-
-    /** Prepares all. */
-    void prepare();
-    /** Populates combo. */
-    void populateCombo();
-
-    /** Holds the value to be selected. */
-    UIColorThemeType  m_enmValue;
-
-    /** Holds the label instance. */
-    QLabel     *m_pLabel;
-    /** Holds the combo instance. */
-    QComboBox  *m_pCombo;
-};
-
-#endif /* !FEQT_INCLUDED_SRC_settings_editors_UIColorThemeEditor_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsInterface.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsInterface.cpp	(revision 107134)
+++ 	(revision )
@@ -1,215 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIGlobalSettingsInterface class implementation.
- */
-
-/*
- * Copyright (C) 2008-2024 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-/* Qt includes: */
-#include <QVBoxLayout>
-#include <QVariant>
-
-/* GUI includes: */
-#include "UIColorThemeEditor.h"
-#include "UIExtraDataManager.h"
-#include "UIGlobalSettingsInterface.h"
-
-
-/** Global settings: User Interface page data structure. */
-struct UIDataSettingsGlobalInterface
-{
-    /** Constructs data. */
-    UIDataSettingsGlobalInterface()
-        : m_enmColorTheme(UIColorThemeType_Auto)
-    {}
-
-    /** Returns whether the @a other passed data is equal to this one. */
-    bool equal(const UIDataSettingsGlobalInterface &other) const
-    {
-        return    true
-               && (m_enmColorTheme == other.m_enmColorTheme)
-                  ;
-    }
-
-    /** Returns whether the @a other passed data is equal to this one. */
-    bool operator==(const UIDataSettingsGlobalInterface &other) const { return equal(other); }
-    /** Returns whether the @a other passed data is different from this one. */
-    bool operator!=(const UIDataSettingsGlobalInterface &other) const { return !equal(other); }
-
-    /** Holds the color-theme. */
-    UIColorThemeType  m_enmColorTheme;
-};
-
-
-/*********************************************************************************************************************************
-*   Class UIGlobalSettingsInterface implementation.                                                                              *
-*********************************************************************************************************************************/
-
-UIGlobalSettingsInterface::UIGlobalSettingsInterface()
-    : m_pCache(0)
-    , m_pEditorColorTheme(0)
-{
-    prepare();
-}
-
-UIGlobalSettingsInterface::~UIGlobalSettingsInterface()
-{
-    cleanup();
-}
-
-bool UIGlobalSettingsInterface::changed() const
-{
-    return m_pCache ? m_pCache->wasChanged() : false;
-}
-
-void UIGlobalSettingsInterface::loadToCacheFrom(QVariant &data)
-{
-    /* Sanity check: */
-    if (!m_pCache)
-        return;
-
-    /* Fetch data to properties: */
-    UISettingsPageGlobal::fetchData(data);
-
-    /* Clear cache initially: */
-    m_pCache->clear();
-
-    /* Cache old data: */
-    UIDataSettingsGlobalInterface oldData;
-    oldData.m_enmColorTheme = gEDataManager->colorTheme();
-    m_pCache->cacheInitialData(oldData);
-
-    /* Upload properties to data: */
-    UISettingsPageGlobal::uploadData(data);
-}
-
-void UIGlobalSettingsInterface::getFromCache()
-{
-    /* Sanity check: */
-    if (!m_pCache)
-        return;
-
-    /* Load old data from cache: */
-    const UIDataSettingsGlobalInterface &oldData = m_pCache->base();
-    if (m_pEditorColorTheme)
-        m_pEditorColorTheme->setValue(oldData.m_enmColorTheme);
-
-    /* Revalidate: */
-    revalidate();
-}
-
-void UIGlobalSettingsInterface::putToCache()
-{
-    /* Sanity check: */
-    if (!m_pCache)
-        return;
-
-    /* Prepare new data: */
-    UIDataSettingsGlobalInterface newData;
-
-    /* Cache new data: */
-    if (m_pEditorColorTheme)
-        newData.m_enmColorTheme = m_pEditorColorTheme->value();
-    m_pCache->cacheCurrentData(newData);
-}
-
-void UIGlobalSettingsInterface::saveFromCacheTo(QVariant &data)
-{
-    /* Fetch data to properties: */
-    UISettingsPageGlobal::fetchData(data);
-
-    /* Update data and failing state: */
-    setFailed(!saveData());
-
-    /* Upload properties to data: */
-    UISettingsPageGlobal::uploadData(data);
-}
-
-void UIGlobalSettingsInterface::sltRetranslateUI()
-{
-}
-
-void UIGlobalSettingsInterface::prepare()
-{
-    /* Prepare cache: */
-    m_pCache = new UISettingsCacheGlobalInterface;
-    AssertPtrReturnVoid(m_pCache);
-
-    /* Prepare everything: */
-    prepareWidgets();
-
-    /* Apply language settings: */
-    sltRetranslateUI();
-}
-
-void UIGlobalSettingsInterface::prepareWidgets()
-{
-    /* Prepare main layout: */
-    QVBoxLayout *pLayout = new QVBoxLayout(this);
-    if (pLayout)
-    {
-        /* Prepare 'color-theme' editor: */
-        m_pEditorColorTheme = new UIColorThemeEditor(this);
-        if (m_pEditorColorTheme)
-        {
-            addEditor(m_pEditorColorTheme);
-            pLayout->addWidget(m_pEditorColorTheme);
-        }
-
-        /* Add stretch to the end: */
-        pLayout->addStretch();
-    }
-}
-
-void UIGlobalSettingsInterface::cleanup()
-{
-    /* Cleanup cache: */
-    delete m_pCache;
-    m_pCache = 0;
-}
-
-bool UIGlobalSettingsInterface::saveData()
-{
-    /* Sanity check: */
-    if (!m_pCache)
-        return false;
-
-    /* Prepare result: */
-    bool fSuccess = true;
-    /* Save settings from cache: */
-    if (   fSuccess
-        && m_pCache->wasChanged())
-    {
-        /* Get old data from cache: */
-        const UIDataSettingsGlobalInterface &oldData = m_pCache->base();
-        /* Get new data from cache: */
-        const UIDataSettingsGlobalInterface &newData = m_pCache->data();
-
-        /* Save 'color-theme': */
-        if (   fSuccess
-            && newData.m_enmColorTheme != oldData.m_enmColorTheme)
-            /* fSuccess = */ gEDataManager->setColorTheme(newData.m_enmColorTheme);
-    }
-    /* Return result: */
-    return fSuccess;
-}
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsInterface.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsInterface.h	(revision 107134)
+++ 	(revision )
@@ -1,100 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIGlobalSettingsInterface class declaration.
- */
-
-/*
- * Copyright (C) 2008-2024 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-#ifndef FEQT_INCLUDED_SRC_settings_global_UIGlobalSettingsInterface_h
-#define FEQT_INCLUDED_SRC_settings_global_UIGlobalSettingsInterface_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-/* GUI includes: */
-#include "UISettingsPage.h"
-
-/* Forward declarations: */
-class UIColorThemeEditor;
-struct UIDataSettingsGlobalInterface;
-typedef UISettingsCache<UIDataSettingsGlobalInterface> UISettingsCacheGlobalInterface;
-
-/** Global settings: User Interface page. */
-class SHARED_LIBRARY_STUFF UIGlobalSettingsInterface : public UISettingsPageGlobal
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs User Interface settings page. */
-    UIGlobalSettingsInterface();
-    /** Destructs User Interface settings page. */
-    virtual ~UIGlobalSettingsInterface() RT_OVERRIDE;
-
-protected:
-
-    /** Returns whether the page content was changed. */
-    virtual bool changed() const RT_OVERRIDE;
-
-    /** Loads settings from external object(s) packed inside @a data to cache.
-      * @note  This task WILL be performed in other than the GUI thread, no widget interactions! */
-    virtual void loadToCacheFrom(QVariant &data) RT_OVERRIDE;
-    /** Loads data from cache to corresponding widgets.
-      * @note  This task WILL be performed in the GUI thread only, all widget interactions here! */
-    virtual void getFromCache() RT_OVERRIDE;
-
-    /** Saves data from corresponding widgets to cache.
-      * @note  This task WILL be performed in the GUI thread only, all widget interactions here! */
-    virtual void putToCache() RT_OVERRIDE;
-    /** Saves settings from cache to external object(s) packed inside @a data.
-      * @note  This task WILL be performed in other than the GUI thread, no widget interactions! */
-    virtual void saveFromCacheTo(QVariant &data) RT_OVERRIDE;
-
-private slots:
-
-    /** Handles translation event. */
-    virtual void sltRetranslateUI() RT_OVERRIDE RT_FINAL;
-
-private:
-
-    /** Prepares all. */
-    void prepare();
-    /** Prepares widgets. */
-    void prepareWidgets();
-    /** Cleanups all. */
-    void cleanup();
-
-    /** Saves existing data from cache. */
-    bool saveData();
-
-    /** Holds the page data cache instance. */
-    UISettingsCacheGlobalInterface *m_pCache;
-
-    /** @name Widgets
-     * @{ */
-        /** Holds the 'color theme' editor instance. */
-        UIColorThemeEditor *m_pEditorColorTheme;
-    /** @} */
-};
-
-#endif /* !FEQT_INCLUDED_SRC_settings_global_UIGlobalSettingsInterface_h */